import GCC
import time
import numpy as np

start_time = time.time()
cards = GCC.new_set(150)
game = GCC.game(cards)
tournament = GCC.tournament(game)
number_of_agents = int(input('How many agents? '))
agentset = GCC.new_agentset(number_of_agents,cards)
number_of_iterations = int(input('How many cycles of iterations? '))
delta_pos = float(input('How much positive variation of prices?(suggest 2) '))
delta_neg = float(input('How much negative variation of prices? (suggest 0.5) '))
tt = int(input('How many iteration before descreasing prices? (suggest 5) '))
verbose = bool(int(input('Verbose? (1 = True, 0 = False) ')))
buyer_trials = int(input('How many trials for buyer? (suggest 3) '))
for i in range(number_of_iterations):
    print('Iteration', i,'...')
    print('Updating money and buying booster...')
    for j in range(len(agentset)):
        agentset[j].update_money()
        agentset[j].take_decision_of_buying_booster(cards)
    print('Card market...')
    if i > 7:
        for j in np.random.permutation(len(agentset)):
            agentset[j].buy_card(agentset,cards,delta_pos,verbose,buyer_trials)
            agentset[j].buy_card(agentset,cards,delta_pos,verbose,buyer_trials)
            if verbose:
                print('Agent',j,'making deck')
            agentset[j].make_deck()
    if i > 7:
        print('Making tournament...')
        tournament.make_tournament(agentset)
    print('Updating parameters...')
    for j in range(len(agentset)):
        agentset[j].update_ite()
        agentset[j].update_MinPrice(delta_neg,tt)
        if i > 7:
            agentset[j].update_Quality(tournament.top_cards(agentset))
time = time.time() - start_time
        
                

